/*
 * Options.h
 *
 *  Created on: Jul 7, 2012
 *      Author: philipp_
 */

#ifndef OPTIONS_H_
#define OPTIONS_H_

#include <getopt.h>

static const struct option long_options[] =
	{
		{ "config", 					required_argument, 0, 'c' },
		{ "output", 					required_argument, 0, 'o' },
		{ "qry",    					required_argument, 0, 'q' },
		{ "q1",	    					required_argument, 0, '1' },
		{ "q2", 	   					required_argument, 0, '2' },
		{ "ref", 						required_argument, 0, 'r' },
		{ "cpu-threads", 				required_argument, 0, 't' },
		{ "gpu", 						optional_argument, 0, 'g' },
		{ "sensitivity", 				required_argument, 0, 's' },
		{ "format", 					required_argument, 0, 'f' },
		{ "mode", 						required_argument, 0, 'm' },
		{ "kmer", 						required_argument, 0, 'k' },
		{ "paired", 					no_argument,       0, 'p' },
//		{ "topn", 						required_argument, 0, 'n' },
		{ "kmer-skip", 					required_argument, 0, 0 },
		{ "corridor", 					required_argument, 0, 0 },
		{ "pre-only", 					no_argument,       0, 0 },
		{ "skip-env", 					no_argument,       0, 0 },
		{ "max-equal", 					required_argument, 0, 0 },
		{ "gpu-dll", 					required_argument, 0, 0 },
		{ "cpu-dll", 					required_argument, 0, 0 },
//		{ "bowtie-mode", 				no_argument,       0, 0 },
		{ "search-table-length", 		required_argument, 0, 0 },
		{ "bs-mapping", 				no_argument		 , 0, 0 },
	0 };

#endif /* OPTIONS_H_ */
